<script lang="ts">
    import DistrictPanel from './components/District/DistrictPanel.svelte'
    import FieldPanel from './components/District/FieldPanel.svelte'
    import Map from './components/District/Map.svelte'
    import Nav from './components/Nav/Nav.svelte'
    import ResourcesPanel from './components/District/ResourcesPanel.svelte'
    import Tailwindcss from './components/Tailwindcss.svelte'
    import Hex from 'lib/map/Hex'
    import DistrictField from 'models/DistrictField'
    import { grid } from 'lib/grid'
    import Building from 'models/Building'

    let field: DistrictField = null
    let isBuilding: boolean
    $: isBuilding =
        field !== null &&
        field.content !== null &&
        Object.prototype.hasOwnProperty.call(field.content, 'level')

    const selectField = (hex: Hex) => {
        clearZeroBuilding()
        field = $grid[hex.r][hex.q + Math.floor(hex.r / 2)]
    }

    // Add a level 0 building in the field
    const handleNew = (building: Building) => {
        field.content = building
    }

    // Empty the field
    const handleCancel = () => {
        clearZeroBuilding()
        field = null
    }

    // Clear the content of a field if it was occupied by a level 0 building
    const clearZeroBuilding = () => {
        if (
            isBuilding &&
            field.content.level === 0 &&
            !field.content.isUnderConstruction()
        ) {
            field.content = null
        }
    }
</script>

<Tailwindcss />

<header>
    <ResourcesPanel />
    <Nav />
</header>

<main>
    <aside>
        {#if field === null}
            <DistrictPanel />
        {:else}
            <FieldPanel
                {field}
                {isBuilding}
                on:cancel={handleCancel}
                on:newBuilding={event => handleNew(event.detail.content)}
            />
        {/if}
    </aside>
    <Map on:selectField={event => selectField(event.detail)} />
</main>

<style lang="postcss">
    main,
    header {
        @apply grid grid-cols-5 gap-x-2 m-4;
    }
    main > :last-child {
        @apply col-span-4;
    }
    aside {
        @apply bg-purple-300 p-4 rounded-lg h-full text-sm;
    }
</style>
